#include <stdio.h>
#include <stdlib.h>

void print_bits(unsigned int x){
	int broj_bitova = sizeof(int) * 8;
	unsigned mask = 1 << (broj_bitova - 1);
	
	int i;
	for(i = 0; i < broj_bitova; i++){
		unsigned rez = x & mask;
		if(rez == 0)
			printf("0");
		else
			printf("1");
		mask = mask >> 1;
	}
	
	printf("\n");
}

unsigned get_bits(unsigned x, int p, int n){
	unsigned mask = (~((~0)<<n))<<p;
	return (x & mask) >> p;
}

unsigned set_bits(unsigned x, int p, int n, unsigned y){
	//x = ABC
	//y = 00D
	//x -> A0C
	//y -> 0D0
	//or nad gornja 2
	//A0C -> ABC & 101
	//0D0 -> 00D << p
	
	unsigned mask_101 = ~((~((~0)<<n))<<p);
	return (x & mask_101) | (y << p);
}

unsigned invert_bits(unsigned x, int p, int n){
	//broj A B C
	// ->  A~B C
	unsigned mask_010 = (~((~0)<<n))<<p;
	return x ^ mask_010;
}

unsigned right_rotate(unsigned x, int n){
	unsigned desni_bitovi = get_bits(x, 0, n);
	x = x >> n;
	int bc = 8 * sizeof(unsigned);
	return set_bits(x, bc - n, n, desni_bitovi);
}

void greska(){
	printf("-1");
	exit(EXIT_FAILURE);
}

int main(){
	unsigned x = 0xFFAAFF00; //1111 1111 1010 1010 1111 1111 0000 0000
	unsigned y = 0x00001102; //0000 0000 0000 0000 0001 0001 0000 0010
	//pravimo    0xFF102F00  //1111 1111 0001 0000 0010 1111 0000 0000
	print_bits(x);
	print_bits(get_bits(x, 12, 16));
	print_bits(set_bits(x, 12, 12, y));

	printf("unesite x: ");
	scanf("%u", &x);
	printf("unesite p i n: ");
	int p, n;
	scanf("%d%d", &p, &n);
	
	if(p < 0 || n < 0)
		greska();		
	
	int broj_bitova = 8 * sizeof(unsigned);
	if(!(p + n < broj_bitova))
		greska(); 

	print_bits(x);
	print_bits(invert_bits(x, p, n));
	printf("rotacija: \n");
	
	print_bits(right_rotate(x, p));
	return 0;
}








