//ucitavamo studente iz datoteke sve dok ne dodjemo do kraja
//broj studenata nije unapred poznat
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAX 100

typedef struct _student{
	char ime[MAX];
	char prezime[MAX];
	char indeks[MAX];
	int ocena;
}student;

void greska(){
	printf("-1\n");
	exit(EXIT_FAILURE);
}

//ime datoteke se prosledjuje kao arg. kom. lin.
//na kraju ispisujemo prosecnu ocenu na 2 decimale
int main(int argc, char **argv){
	if(argc != 2)
		greska();

	FILE *f = fopen(argv[1], "r");
	if(f == NULL)
		greska();

	//moramo da inicijalizujemo na NULL kako bi realloc radio
	student *s = NULL;
	int ns = 0;
	
	char tmp_ime[MAX];
	char tmp_prezime[MAX];
	char tmp_indeks[MAX];
	int tmp_ocena;

	while(fscanf(f, "%s%s%s%d", tmp_ime, tmp_prezime, tmp_indeks, &tmp_ocena) == 4){
		ns++;
		s = realloc(s, ns * sizeof(student));
		if(s == NULL)
			greska();
		
		strcpy(s[ns-1].ime, tmp_ime);
		strcpy(s[ns-1].prezime, tmp_prezime);
		strcpy(s[ns-1].indeks, tmp_indeks);
		s[ns-1].ocena = tmp_ocena;
	}

	int i;
	float prosek = 0;
	for(i = 0; i < ns; i++)
		prosek += s[i].ocena;
	
	prosek /= ns;
	printf("prosek je %.2f\n", prosek);
	
	fclose(f);
	free(s);
	return 0;
}
